MT.ALCHP	EQU	$18
MT.LPOLL	EQU	$1C
BP.INIT 	EQU	$110
SV_SCRST	EQU	$33
SV_MCSTA	EQU	$34
SV_SER1C	EQU	$98
SV_SER2C	EQU	$9C
SV_MDRUN	EQU	$EE
MC_STAT 	EQU	$18063
MC_SCRN 	EQU	$7
BV_RIP		EQU	$58
*
* First Initialise the Extra Basic Procedures
*
		SECTION CODE

		MOVE.W	BP.INIT,A2
		LEA	PROC_DEF(PC),A1
		JSR	(A2)
*
* Now reserve the second screen
*
		MOVEQ	#MT.ALCHP,D0
		MOVE.L	#$6BE0,D1
		TRAP	#1
		TST.L	D0
		BNE.S	EXIT
*
* Now link in the interrupt handler
*
*		 LEA	 INT_SERVE(PC),A1
*		 MOVEQ	 #MT.LPOLL,D0
*		 LEA	 INT_LINK(PC),A0
*		 MOVE.L  A1,4(A0)
*		 TRAP	 #1
EXIT
		 RTS
*
* Basic procedure definitions
*
PROC_DEF
		DC.W	3
		DC.W	SCRA-*
		DC.B	4,'SCRA'
		DC.W	SCR0-*
		DC.B	4,'SCR0'
		DC.W	SCR1-*
		DC.B	4,'SCR1'
		DC.W	0
		DC.W	1
		DC.W	SCRNUM-*
		DC.B	6,'SCRNUM'

*
* Set screen auto toggle
*
SCRA
		LEA	SCR_AUTO(PC),A1
		ST	(A1)
		BRA.S	EXIT_OK
*
* Set to Screen 0
*
SCR0		 LEA	SCR_AUTO(PC),A1
		 CLR.W	(A1)
		 BRA.S	EXIT_OK
*
* Set to Screen 1
*
SCR1		 LEA	SCR_AUTO(PC),A1
		 MOVE.W #$00FF,(A1)
		 BRA.S	EXIT_OK
*
* Find which screen is displayed
*
SCRNUM		MOVE.L	BV_RIP(A6),A1
		SUBQ.W	#2,A1
		MOVE.L	A1,BV_RIP(A6)
		MOVEQ	#1,D1		return 1
		AND.B	SCR_1(PC),D1	... or 0
		MOVE.W	D1,(A6,A1.L)
		MOVEQ	#3,D4		type is integer
EXIT_OK
		MOVEQ	#0,D0
		RTS
*
*
* Interupt Service
*
SCR_AUTO	DS.B	1
SCR_1		DS.B	1
INT_LINK	DS.L	2		link and entry address
INT_BASE	EQU	INT_LINK-8	link table (A3 on entry)
INT_SERVE
		MOVE.B	SV_MCSTA(A6),D1 reset to screen 0
		MOVE.B	D1,MC_STAT
*
		TST.B	SCR_1-INT_BASE(A3)	is screen 1 required
		BEQ.S	INT_TOGGLE		... no give up
		TST.L	SV_SER1C(A6)		is serial 1 open
		BNE.S	EXIT_INT		... yes timings wrong
		TST.L	SV_SER2C(A6)		is serial 2 open
		BNE.S	EXIT_INT		... yes timings wrong
		TST.B	SV_MDRUN(A6)		is a microdrive running
		BNE.S	EXIT_INT		... yes timings wrong
*
		MOVE.W	#1360,D0		wait for system variables
		DBRA	D0,*			to pass
*
		BSET	#MC_SCRN,D1
		MOVE.B	D1,MC_STAT
*
INT_TOGGLE
		TST.B	SCR_AUTO-INT_BASE(A3)	CTRL F5 toggling
		BEQ.S	EXIT_INT		.... no
		TST.B	SV_SCRST(A6)		has CTRL F5 been pressed
		BEQ.S	EXIT_INT		.... no
		SF	SV_SCRST(A6)
		NOT.B	SCR1-INT_BASE(A3)
EXIT_INT
		RTS

		END
